#include "Bin2bmp.inc"

.data
pBitmap		INCBIN "Fish.bmp"
pDlgTemp	INCBIN "rsrc.res",50h	;Skip the header to point the raw resource data
hInstance		dd ?
hBitmap		dd ?
ppvBits		dd ?

.code
start:
	invoke	GetModuleHandle,0
	mov	[hInstance],eax
	invoke	DialogBoxIndirectParam,[hInstance],ADDR pDlgTemp,0,ADDR DlgProc,0
	invoke	ExitProcess,eax

DlgProc FRAME hWnd,uMsg,wParam,lParam

LOCAL	ps:PAINTSTRUCT
LOCAL	hdc:D
LOCAL	hMemDC:D

	cmp	d[uMsg],WM_CLOSE
		
		jne	>initdlg
		invoke	EndDialog,[hWnd],0
		jmp	>true
initdlg:	
	cmp	d[uMsg],WM_INITDIALOG
	
		jne	>paint
		lea	eax,[pBitmap+SIZEOF BITMAPFILEHEADER] ; start of BITMAPINFOHEADER header
		invoke	CreateDIBSection,0,eax,DIB_RGB_COLORS,ADDR ppvBits,0,0
      		mov	[hBitmap],eax
      		lea	eax,[pBitmap+54] ; + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER)
      		invoke	MemCopy,eax,[ppvBits],30854-54 ; copy bitmap's bit values
		jmp	>true
paint:
	cmp	d[uMsg],WM_PAINT
	
		jne	>false
		invoke	BeginPaint,[hWnd],ADDR ps
      		mov	[hdc],eax
      		invoke	CreateCompatibleDC,eax
      		mov	[hMemDC],eax
      		invoke	SelectObject,eax,[hBitmap]
      		lea	edx,[pBitmap+SIZEOF BITMAPFILEHEADER] ; start of BITMAPINFOHEADER header
		invoke	BitBlt,[hdc],0,0,[edx+BITMAPINFOHEADER.biWidth],[edx+BITMAPINFOHEADER.biHeight],[hMemDC],0,0,SRCCOPY
      		invoke	DeleteDC,[hMemDC]
      		invoke	EndPaint,[hWnd],ADDR ps
		jmp	>true
false:
		xor	eax,eax
		ret
true:
	mov	eax,1
	ret
ENDF

MemCopy FRAME Source,Dest,ln   ; procedure from masm32 library

	cld
	mov esi, [Source]
	mov edi, [Dest]
	mov ecx, [ln]
	shr ecx, 2
	rep movsd
	mov ecx, [ln]
	and ecx, 3
	rep movsb
	ret
ENDF